﻿using HarmonyLib;
using UnityEngine;
//using System;
using System.Collections;
using System.Reflection;

public class zNightmareDifficulty : Mod
{
    private const string HARMONY_ID = "Nigthmare.Difficulty";
    private Harmony harmonyInstance;

    //2)message to players
    private HNotify notify;

    //1)for timer second counter
    public int _ongoingTime = 0;

    //1)for comparision saved time actual time in invulnerability check
    public int _saveTime = 0;

    //1)for identification if gear is worn
    private bool _hasChestItem;
    private bool _hasHeadItem;
    private bool _hasFootItem;

    public void Start()
    {
        ComponentManager<zNightmareDifficulty>.Value = this;

        harmonyInstance = new Harmony(HARMONY_ID);
        harmonyInstance.PatchAll(Assembly.GetExecutingAssembly());

        //2)messages to players
        notify = FindObjectOfType<HNotify>();

        Debug.Log("Mod zNightmareDifficulty has been loaded!");
        //1)needed timer function
        StartCoroutine(time());
    }

    public void OnModUnload()
    {
        Debug.Log("Mod zNightmareDifficulty has been unloaded!");
        //1)needed timer function
        StopCoroutine(time());

        harmonyInstance.UnpatchAll(HARMONY_ID);
    }

    //1)real time function second counter
    IEnumerator time()
    {
        while (true)
        {
            timeCount();
            yield return new WaitForSeconds(1);
        }
    }
    void timeCount()
    {
        _ongoingTime += 1;
    }

    //1)check if gear is worn and adding defense for each gear piece, whole set gives bonus
    public override void LocalPlayerEvent_Hurt(float damage, Vector3 hitPoint, Vector3 hitNormal, EntityType damageInflictorEntityType)
    {
        var _dmgReduceChest = 0f;
        var _dmgReduceFoot = 0f;
        var _dmgReduceHead = 0f;
        var _dmgReduceWhole = 0f;

        Network_Player player = RAPI.GetLocalPlayer();
        if (player != null)
            foreach (Slot_Equip slot in player.Inventory.equipSlots)
                if (slot.slotType == SlotType.Equipment && slot.GetItemBase() != null &&
                    slot.GetItemBase().settings_equipment.EquipType == EquipSlotType.Chest)
                {
                    _hasChestItem = true;
                    if (_hasChestItem == true)
                    {
                        _dmgReduceChest = 12f;
                    }
                    //RAPI.BroadcastChatMessage("errortruechest");
                }

        if (player != null)
            foreach (Slot_Equip slot in player.Inventory.equipSlots)
                if (slot.slotType == SlotType.Equipment && slot.GetItemBase() != null &&
                    slot.GetItemBase().settings_equipment.EquipType == EquipSlotType.Feet)
                {
                    _hasFootItem = true;
                    if (_hasFootItem == true)
                    {
                        _dmgReduceFoot = 8f;
                    }
                    //RAPI.BroadcastChatMessage("errortruefoot");
                }

        if (player != null)
            foreach (Slot_Equip slot in player.Inventory.equipSlots)
                if (slot.slotType == SlotType.Equipment && slot.GetItemBase() != null &&
                    slot.GetItemBase().settings_equipment.EquipType == EquipSlotType.Head)
                {
                    _hasHeadItem = true;
                    if (_hasHeadItem == true)
                    {
                        _dmgReduceHead = 8f;
                    }
                    //RAPI.BroadcastChatMessage("errortruehead");
                }

        if (_dmgReduceChest + _dmgReduceFoot + _dmgReduceHead == 28f)
        {
            _dmgReduceWhole = 12f;
        }
        //1)first is avoid dmg on healing, second is dmg reduction with gear, third is invulnerability for 1 second, buffs will work normally including dmg buff from puffer fish
        if (damage < 0)
        { }
        else
        {
            if (_ongoingTime - _saveTime > 1)
            {
                RAPI.GetLocalPlayer().Stats.stat_health.Value = RAPI.GetLocalPlayer().Stats.stat_health.Value - 50 *
                    (1 - ((_dmgReduceChest + _dmgReduceFoot + _dmgReduceHead + _dmgReduceWhole) / 100));
                _hasChestItem = false;
                _hasFootItem = false;
                _hasHeadItem = false;
                _dmgReduceChest = 0f;
                _dmgReduceFoot = 0f;
                _dmgReduceHead = 0f;
                _dmgReduceWhole = 0f;
            }
            else
            { }
        }
        _saveTime = _ongoingTime;
    }

    [ConsoleCommand(name: "revive", docs: "Revives you if you are dead. You need to have a bed on your raft for it to work.")]
    public static void reviveCommand(string[] args)
    {
        if (RAPI.GetLocalPlayer() == null) return;

        var beds = FindObjectsOfType<Bed>();
        if (beds.Length < 1)
        {
            Debug.Log("You do not have a bed on your raft.");
            return;
        }

        RAPI.GetLocalPlayer().PlayerScript.IsDead = true;
        RAPI.GetLocalPlayer().canvas.OpenMenuCloseOther(MenuType.DeathMenu, true);
        RAPI.BroadcastChatMessage("Find another way to cheat the death ^^");
        //healCommand(null);
        //RAPI.GetLocalPlayer().PlayerScript.StartRespawn(beds[0], false, false);
    }

}